<?php
class Expedice extends Super{

  protected $id;
  protected $nazev;
  protected $popis;
  protected $stav = 1;  // default stav 

  protected $getter = array('id', 'nazev', 'popis', 'stav');
  protected $setter = array( 'nazev', 'popis', 'stav');
  public $validate = array(
  	'id'     => array('required' => 'true'),
  	'nazev'  => array('required' => 'true', 'maxlength' => 35),
    'popis'  => array(),
    'stav'   => array('range' => '[0,1]' ) );
  public $state_validate = array();
  
  public $valAll = array(
  	'id'     => true,
  	'nazev'  => true,
    'popis'  => true,
    'stav'   => true
  );

  function __construct() {
    /*
     * stavy:
     * 1 - aktivní
     * 2 - neaktivní
     */
    $state_validate[1] = $this->valAll;
    $state_validate[0] = $this->valAll;
    
    $this->table = 'EXPEDICE';
    $registry    = Registry::getInstance();

  }


  public function getAll() {
    $res = dibi::query('SELECT E.*, S.NAZEV AS S_NAZEV
		FROM ['.$this->table.'] AS E
    	INNER JOIN [STAV] AS S ON S.STAV_ID = E.STAV AND S.ENTITA = %s',
        $this->table);
    return $res->fetchAssoc('ID');
  }
  
  public function getToSelect() {
    $res = dibi::query('SELECT E.*
    	FROM ['.$this->table.'] AS E
    	WHERE STAV = %i',
         1);
    return $res->fetchAssoc('ID');
  }
 

  public function loadById($id, $hash = false, $postRestore = false) {
    $result = dibi::query('SELECT  E.*, S.NAZEV AS S_NAZEV, S.POPIS AS S_POPIS FROM ['.$this->table.'] AS E 
    	INNER JOIN STAV AS S ON S.STAV_ID = E.STAV AND ENTITA = %s
    	WHERE E.ID = %i;', $this->table, $id);

    if (count($result) == 0) {
      throw new Appliexception(1, 'Požadovaný záznam neexistuje', 'seznam', __METHOD__.' Neexistující záznam '.$id );
    }

    $row = $result->fetch()->getArrayCopy();
    $this->setFromRow($row);
    $this->my_stav = '<div title="'.$row['S_POPIS'].'" class="block_state"> '.$row['STAV'].' - '.$row['S_NAZEV'].'</div><br />';

    if ($hash) {
      $this->hash  = $this->getHash();
    } 

    $this->myStates();

    if ($postRestore) {
      $this->setFromPost();
    }
    return $this->toArray();
  }

}
?>